//
//  _1024_TonePlayerPlugIn.m
//  _1024_TonePlayer
//
//  Created by franz on 3/17/10.
//  Copyright (c) 2010 __MyCompanyName__. All rights reserved.
//

/* It's highly recommended to use CGL macros instead of changing the current context for plug-ins that perform OpenGL rendering */
#import <OpenGL/CGLMacro.h>
#import <AudioToolbox/AudioToolbox.h>
#import <ScreenSaver/ScreenSaver.h>
#import "TonePlayer.h"


#import "_1024_TonePlayerPlugIn.h"

#define	kQCPlugIn_Name				@"_1024_TonePlayer"
#define	kQCPlugIn_Description		@"_1024_TonePlayer description"

@implementation _1024_TonePlayerPlugIn
@dynamic inputPlay;
@dynamic inputFrequency;


static const int kStartFrequency = 64;
float  data[44400];

/*
Here you need to declare the input / output properties as dynamic as Quartz Composer will handle their implementation
@dynamic inputFoo, outputBar;
*/

+ (NSDictionary*) attributes
{
	/*
	Return a dictionary of attributes describing the plug-in (QCPlugInAttributeNameKey, QCPlugInAttributeDescriptionKey...).
	*/
	
	return [NSDictionary dictionaryWithObjectsAndKeys:kQCPlugIn_Name, QCPlugInAttributeNameKey, kQCPlugIn_Description, QCPlugInAttributeDescriptionKey, nil];
}

+ (NSDictionary*) attributesForPropertyPortWithKey:(NSString*)key
{
	if([key isEqualToString:@"inputFrequency"])
	{
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Frequency", QCPortAttributeNameKey,
				[NSNumber numberWithUnsignedInteger:1], QCPortAttributeMinimumValueKey,
				[NSNumber numberWithUnsignedInteger:64], QCPortAttributeDefaultValueKey,
				[NSNumber numberWithUnsignedInteger:200],QCPortAttributeMaximumValueKey,
				nil];
	}
	if([key isEqualToString:@"inputPlay"])
	{
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Play", QCPortAttributeNameKey, nil];
	}
	
	return nil;
}

+ (QCPlugInExecutionMode) executionMode
{
	/*
	Return the execution mode of the plug-in: kQCPlugInExecutionModeProvider, kQCPlugInExecutionModeProcessor, or kQCPlugInExecutionModeConsumer.
	*/
	
	return kQCPlugInExecutionModeConsumer;
}

+ (QCPlugInTimeMode) timeMode
{
	/*
	Return the time dependency mode of the plug-in: kQCPlugInTimeModeNone, kQCPlugInTimeModeIdle or kQCPlugInTimeModeTimeBase.
	*/
	
	return kQCPlugInTimeModeNone;
}

- (id) init
{
	if(self = [super init]) {
		/*
		Allocate any permanent resource required by the plug-in.
		*/
	}
	
	return self;
}

- (void) finalize
{
	/*
	Release any non garbage collected resources created in -init.
	*/
	
	[super finalize];
}

- (void) dealloc
{
	/*
	Release any resources created in -init.
	*/
	
	[super dealloc];
}

@end

@implementation _1024_TonePlayerPlugIn (Execution)

- (BOOL) startExecution:(id<QCPlugInContext>)context
{
	player = [[TonePlayer alloc] init];
	
	//	[player setAudioArray:data];    // for later, send a float array directly to audio buffer
	
	[player setFrequency:kStartFrequency];
	
	return YES;
}

- (void) enableExecution:(id<QCPlugInContext>)context
{
//	  for (int i = 0; i < 44400; ++i) {
//		  data[i] = SSRandomFloatBetween(0.0, 1.0);
//	  }
		  
	

}

- (BOOL) execute:(id<QCPlugInContext>)context atTime:(NSTimeInterval)time withArguments:(NSDictionary*)arguments
{
	
	
	if (self.inputPlay) {
		[player start];
		[player setFrequency:self.inputFrequency];
	}else {
		[player stop];
	}

	
	
	return YES;
}

- (void) disableExecution:(id<QCPlugInContext>)context
{
	[player stop];
}

- (void) stopExecution:(id<QCPlugInContext>)context
{
	
	
}

@end
